import { AutocompleteSetters, AutocompleteState, AutocompleteStore, AutocompleteRefresh, BaseItem, InternalAutocompleteOptions } from './types';
interface OnInputParams<TItem extends BaseItem> extends AutocompleteSetters<TItem> {
    query: string;
    event: any;
    store: AutocompleteStore<TItem>;
    props: InternalAutocompleteOptions<TItem>;
    /**
     * The next partial state to apply after the function is called.
     *
     * This is useful when we call `onInput` in a different scenario than an
     * actual input. For example, we use `onInput` when we click on an item,
     * but we want to close the panel in that case.
     */
    nextState?: Partial<AutocompleteState<TItem>>;
    refresh: AutocompleteRefresh;
}
export declare function onInput<TItem extends BaseItem>({ query, event, store, props, setSelectedItemId, setQuery, setCollections, setIsOpen, setStatus, setContext, nextState, refresh, }: OnInputParams<TItem>): Promise<void>;
export {};
